unit Form_Client;
{APPTYPE CONSOLE}
{Historic:

Version 1 (01/06/2006):
 * original issue

Version 2 (23/09/2006):
 * addition of Pax/Pax2 modes (TX/TX/Connection/Disconnection)

Version 3 (25/01/2007):
 * addition of Packet modes (TX/TX/Connection/Disconnection)
 * addition of MIL_STD_188_141A mode (only in "Unproto")

Version 5 (25/12/2008):
 * addition of comments (between CHR(23)...CHR(24)) for Call ID and RS ID reception
 * addition of END_OF_TCP_IP_CONNECTION, MULTIPSK_MINIMIZE, MULTIPSK_RESIZE command
 * "SPECTRUM ?", "AF FR x Hz" and "AF FR ?" are now non-licensed commands

Version 6 (12/03/2009):
 * addition of SdR commands ("SDR_SPECTRUM ?", "SDR_SF [Sampling Frequency in Hz]", "SDR_FR [ Frequency in Hz]"
   "SDR_MODE [ Mode]" (Mode: "USB" or "LSB"), "SDR_VFO [ VFO]" (VFO: "A" or "B"))
 Note: the KISS TCP/IP commands which are very specified are not used here. See the Multipsk help for details.

Version 7 (02/12/2010):
 * addition of the SdR command SDR_HF_FR [ central HF Frequency in Hz for the selected VFO (A or B)]
 * END_OF_TCP_IP_CONNECTION being AMBIGUOUS, CLOSE_MULTIPSK closes Multipsk
 * all TCP/IP functions can be now used without licence

Version 8 (24/06/2022):
 * the TCP/IP address can be any address and not only the local loop 127.0.0.1
 * addition of "BPSK31" and "FT8" commands
 * reorganization of the windows
}

{All functions are not presented here.
For the description of all the functions controlling Multipsk, refer to the
help manual of the TCP/IP window of Multipsk:
* start Multipsk and open the RX/TX screen
* click on the "TCP/IP" button at the Top of the RX/TX screen,
* click on "Help" (or "Aide")}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, ComCtrls,ShellApi;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    GroupBox3: TGroupBox;
    Memo_Reception_Text: TMemo;
    GroupBox1: TGroupBox;
    Memo_Transmission_Text: TMemo;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Memo_Log: TMemo;
    Connection: TSpeedButton;
    Disconnection: TSpeedButton;
    GroupBox7: TGroupBox;
    Memo_reception_commands: TMemo;
    Label1: TLabel;
    Protocol_version: TButton;
    Label2: TLabel;
    RX_Commander: TButton;
    TX_Commander: TButton;
    RX: TButton;
    TX: TButton;
    HF_frequency_via_Commander: TButton;
    Mode_XCVR: TButton;
    Label3: TLabel;
    Label4: TLabel;
    AF_frequency: TButton;
    State: TButton;
    Transceiver_state: TButton;
    Request_AF_Frequency: TButton;
    Request_AF_Level: TButton;
    Request_Signal_to_Noise: TButton;
    Request_squelch: TButton;
    SQUELCH_LEVEL: TButton;
    Edit1: TEdit;
    Manual_command: TButton;
    Label5: TLabel;
    Request_mode: TButton;
    Mode_RTTY_45: TButton;
    Spectrum: TButton;
    Request_Signal_Quality: TButton;
    Request_intermodulation_distorsion: TButton;
    Request_AFC: TButton;
    AFC_ON: TButton;
    Request_Master_or_Slave: TButton;
    Slave: TButton;
    Request_Controls: TButton;
    Very_narrow_filter_in_BPSK31: TButton;
    Request_PC: TButton;
    PC_66_MHZ: TButton;
    Request_Synchro: TButton;
    Sequence_Macros: TButton;
    Alignment_1500_Hz: TButton;
    Tune_ON: TButton;
    Tune_OFF: TButton;
    Pax_connection_state: TButton;
    Connect: TButton;
    Disconnect: TButton;
    RX_AFTER_TX: TButton;
    End_of_TCP_IP_connection: TButton;
    MINIMIZE: TButton;
    RESIZE: TButton;
    Label6: TLabel;
    SdR_Spectrum: TButton;
    Request_SdR_AF_Frequency: TButton;
    SdR_AF_frequency: TButton;
    SDR_USB: TButton;
    SDR_VFO_A: TButton;
    Request_SdR_Sampling_frequency: TButton;
    Label7: TLabel;
    Request_SdR_HF_Frequency: TButton;
    SdR_HF_frequency: TButton;
    Multipsk_closure: TButton;
    Label_hote: TLabel;
    Edit_hote: TEdit;
    FT8: TButton;
    Button1: TButton;
    procedure ConnectionClick(Sender: TObject);
    procedure DisconnectionClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormActivate(Sender: TObject);
    procedure Memo_Transmission_TextKeyPress(Sender: TObject; var Key: Char);
    procedure Protocol_versionClick(Sender: TObject);
    procedure RX_CommanderClick(Sender: TObject);
    procedure TX_CommanderClick(Sender: TObject);
    procedure TXClick(Sender: TObject);
    procedure RXClick(Sender: TObject);
    procedure HF_frequency_via_CommanderClick(Sender: TObject);
    procedure Mode_XCVRClick(Sender: TObject);
    procedure AF_frequencyClick(Sender: TObject);
    procedure StateClick(Sender: TObject);
    procedure Transceiver_stateClick(Sender: TObject);
    procedure Request_AF_FrequencyClick(Sender: TObject);
    procedure Request_AF_LevelClick(Sender: TObject);
    procedure Request_Signal_to_NoiseClick(Sender: TObject);
    procedure Request_squelchClick(Sender: TObject);
    procedure SQUELCH_LEVELClick(Sender: TObject);
    procedure Manual_commandClick(Sender: TObject);
    procedure Request_modeClick(Sender: TObject);
    procedure Mode_RTTY_45Click(Sender: TObject);
    procedure SpectrumClick(Sender: TObject);
    procedure Request_Signal_QualityClick(Sender: TObject);
    procedure Request_intermodulation_distorsionClick(Sender: TObject);
    procedure Request_AFCClick(Sender: TObject);
    procedure AFC_ONClick(Sender: TObject);
    procedure Request_Master_or_SlaveClick(Sender: TObject);
    procedure SlaveClick(Sender: TObject);
    procedure Request_ControlsClick(Sender: TObject);
    procedure Very_narrow_filter_in_BPSK31Click(Sender: TObject);
    procedure Request_PCClick(Sender: TObject);
    procedure PC_66_MHZClick(Sender: TObject);
    procedure Request_SynchroClick(Sender: TObject);
    procedure Sequence_MacrosClick(Sender: TObject);
    procedure Alignment_1500_HzClick(Sender: TObject);
    procedure Tune_ONClick(Sender: TObject);
    procedure Tune_OFFClick(Sender: TObject);
    procedure Pax_connection_stateClick(Sender: TObject);
    procedure ConnectClick(Sender: TObject);
    procedure DisconnectClick(Sender: TObject);
    procedure RX_AFTER_TXClick(Sender: TObject);
    procedure End_of_TCP_IP_connectionClick(Sender: TObject);
    procedure RESIZEClick(Sender: TObject);
    procedure MINIMIZEClick(Sender: TObject);
    procedure SdR_SpectrumClick(Sender: TObject);
    procedure Request_SdR_AF_FrequencyClick(Sender: TObject);
    procedure SdR_AF_frequencyClick(Sender: TObject);
    procedure Request_SdR_Sampling_frequencyClick(Sender: TObject);
    procedure SDR_USBClick(Sender: TObject);
    procedure SDR_VFO_AClick(Sender: TObject);
    procedure Request_SdR_HF_FrequencyClick(Sender: TObject);
    procedure SdR_HF_frequencyClick(Sender: TObject);
    procedure FT8Click(Sender: TObject);
    procedure Multipsk_closureClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

VAR Datetime:TDateTime;
var Date_Str: string;
VAR FOCUS_ON_MEMO_RECEPTION:HWND;
VAR RECEPTION_OF_RECEIVED_TEXT:BOOLEAN=FALSE;
VAR RECEPTION_OF_TRANSMITTED_TEXT:BOOLEAN=FALSE;
VAR RECEPTION_OF_COMMANDS:BOOLEAN=FALSE;
VAR RECEPTION_OF_COMMENTS:BOOLEAN=FALSE;
VAR TEXT_OF_THE_COMMAND:STRING='';
VAR TEXT_OF_THE_COMMENT:STRING='';

{$R *.dfm}
{************}

procedure TForm1.ConnectionClick(Sender: TObject);
VAR CHAINE:STRING;
begin
 {V.8}
 CHAINE:=Form1.Edit_hote.Text;
 Form1.ClientSocket1.Host:=CHAINE;
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Connexion asked');
 ClientSocket1.Open;
end;

{***********}

procedure TForm1.DisconnectionClick(Sender: TObject);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 Memo_Log.Lines.Add(Date_Str+': '+'Disconnexion asked');
 {Close the socket connexion}
 ClientSocket1.Close;
end;

{**********}

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is connected to the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Connected to '+Socket.RemoteHost);
 Form1.Connection.down:=TRUE;
end;

{**********}

procedure TForm1.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the server is being searched by the client}
 Memo_Log.Lines.Add(Date_Str+': '+'The server is being searched');
end;

{**********}

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is going to disconnect from the server}
 Memo_Log.Lines.Add(Date_Str+': '+'Disconnected');
 Form1.Disconnection.down:=TRUE;
end;

{**********}

procedure MANAGEMENT_OF_THE_RECEIVED_COMMAND;
{command in TEXT_OF_THE_COMMAND}
BEGIN
 {this void part will be managed by the author of the program, according to his needs}

 TEXT_OF_THE_COMMAND:='';
END;


{**********}

procedure MANAGEMENT_OF_THE_RECEIVED_COMMENT;
{comment in TEXT_OF_THE_COMMENT}
BEGIN
 {this void part will be managed by the author of the program, according to his needs}

 TEXT_OF_THE_COMMENT:='';
END;


{**********}

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
{management of a received string of characters}
VAR RECEIVED:STRING;
VAR COUNTER:LONGINT;
begin
 DateTime := Time; Date_str := TimeToStr(DateTime);
 RECEIVED:=Socket.ReceiveText;

 FOR COUNTER:=1 TO LENGTH(RECEIVED) DO
 BEGIN
  {Characters effectively transmitted by Multipsk to the transceiver}
  IF (RECEPTION_OF_TRANSMITTED_TEXT=FALSE) AND (RECEPTION_OF_RECEIVED_TEXT=FALSE) AND
   (RECEPTION_OF_COMMANDS=FALSE) AND (RECEPTION_OF_COMMENTS=FALSE) AND (RECEIVED[COUNTER]=CHR(28)) THEN
   RECEPTION_OF_TRANSMITTED_TEXT:=TRUE ELSE IF (RECEPTION_OF_TRANSMITTED_TEXT=TRUE) THEN
  BEGIN
   {these characters are not used by the demonstration program but could be used by a complete TX editor.}
   {WRITELN(ORD(RECEIVED[COUNTER]));}
   RECEPTION_OF_TRANSMITTED_TEXT:=FALSE;
  END ELSE

  {Characters received by Multipsk}
  IF (RECEPTION_OF_TRANSMITTED_TEXT=FALSE) AND (RECEPTION_OF_RECEIVED_TEXT=FALSE) AND
   (RECEPTION_OF_COMMANDS=FALSE) AND (RECEPTION_OF_COMMENTS=FALSE) AND (RECEIVED[COUNTER]=CHR(29)) THEN
   RECEPTION_OF_RECEIVED_TEXT:=TRUE ELSE IF (RECEPTION_OF_RECEIVED_TEXT=TRUE) THEN
  BEGIN
   SENDMESSAGE(FOCUS_ON_MEMO_RECEPTION,WM_CHAR,ORD(RECEIVED[COUNTER]),0);
   RECEPTION_OF_RECEIVED_TEXT:=FALSE;
  END ELSE

  {Commands}
  IF (RECEPTION_OF_TRANSMITTED_TEXT=FALSE) AND (RECEPTION_OF_RECEIVED_TEXT=FALSE) AND
   (RECEPTION_OF_COMMANDS=FALSE) AND (RECEPTION_OF_COMMENTS=FALSE) AND (RECEIVED[COUNTER]=CHR(30)) THEN
   RECEPTION_OF_COMMANDS:=TRUE ELSE IF (RECEPTION_OF_COMMANDS=TRUE) AND (RECEIVED[COUNTER]=CHR(31)) THEN
  BEGIN
   {display the answer to the command}
   Memo_reception_Commands.Lines.Add(Date_str+' Answer: '+TEXT_OF_THE_COMMAND);
   {end of reception of the command, it must be managed}
   MANAGEMENT_OF_THE_RECEIVED_COMMAND;
   RECEPTION_OF_COMMANDS:=FALSE;
  END ELSE
  IF RECEPTION_OF_COMMANDS=TRUE THEN TEXT_OF_THE_COMMAND:=TEXT_OF_THE_COMMAND+RECEIVED[COUNTER] ELSE

  {Comments}
  IF (RECEPTION_OF_TRANSMITTED_TEXT=FALSE) AND (RECEPTION_OF_RECEIVED_TEXT=FALSE) AND
   (RECEPTION_OF_COMMANDS=FALSE) AND (RECEPTION_OF_COMMENTS=FALSE) AND (RECEIVED[COUNTER]=CHR(23)) THEN
   RECEPTION_OF_COMMENTS:=TRUE ELSE IF (RECEPTION_OF_COMMENTS=TRUE) AND (RECEIVED[COUNTER]=CHR(24)) THEN
  BEGIN
   {display the answer to the command}
   Memo_reception_Commands.Lines.Add(Date_str+' Comment: '+TEXT_OF_THE_COMMENT);
   {end of reception of the comment, it must be managed}
   MANAGEMENT_OF_THE_RECEIVED_COMMENT;
   RECEPTION_OF_COMMENTS:=FALSE;
  END ELSE
  IF RECEPTION_OF_COMMENTS=TRUE THEN TEXT_OF_THE_COMMENT:=TEXT_OF_THE_COMMENT+RECEIVED[COUNTER] ELSE

  {Error}
  BEGIN
   DateTime := Time; Date_str := TimeToStr(DateTime);
   Memo_Log.Lines.Add(Date_Str+': '+'Unknown received character');
  END;
 END;
end;

{**********}

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var ErrorMsg: string;
begin
 {definition of the error message according to the error code}
 case ErrorCode of
  10004 : ErrorMsg:='Interrupted function call.';
  10013 : ErrorMsg:='Permission denied.';
  10014 : ErrorMsg:='Bad address.';
  10022 : ErrorMsg:='Invalid argument.';
  10024 : ErrorMsg:='Too many open files. Actually, it''s too many open sockets.';
  10035 : ErrorMsg:='Resource temporarily unavailable.';
  10036 : ErrorMsg:='Operation now in progress. A blocking operation is in progress.';
  10037 : ErrorMsg:='Operation already in progress.';
  10038 : ErrorMsg:='Socket operation on non-socket.';
  10039 : ErrorMsg:='Destination address required.';
  10040 : ErrorMsg:='Message too long.';
  10041 : ErrorMsg:='Protocol wrong type for socket.';
  10042 : ErrorMsg:='Bad protocol option.';
  10043 : ErrorMsg:='Protocol not supported.';
  10044 : ErrorMsg:='Socket type not supported.';
  10045 : ErrorMsg:='Operation not supported.';
  10046 : ErrorMsg:='Protocol family not supported.';
  10047 : ErrorMsg:='Address family not supported by protocol family.';
  10048 : ErrorMsg:='Address is already in use. If you attempt to set up a server on a port that is already is in use, you will get this error.';
  10049 : ErrorMsg:='Cannot assign requested address.';
  10050 : ErrorMsg:='Network is down.';
  10051 : ErrorMsg:='Network is unreachable.';
  10052 : ErrorMsg:='Network dropped connection on reset.';
  10053 : ErrorMsg:='Software caused the connection to abort. A connection that has been made was aborted, usually due to connection or protocol error.';
  10054 : ErrorMsg:='Connection reset by peer. This occurs when an established connection is shut down for some reason by the remote computer.';
  10055 : ErrorMsg:='No buffer space available.';
  10056 : ErrorMsg:='Socket is already connected.';
  10057 : ErrorMsg:='Socket is not connected.';
  10058 : ErrorMsg:='Cannot send after socket shutdown.';
  10060 : ErrorMsg:='Connection timed out.';
  10061 : ErrorMsg:='Connection refused. You will usually see this error when a server refuses a connection from a client, because the server is not listening on that port.';
  10064 : ErrorMsg:='Host is down.';
  10065 : ErrorMsg:='No route to host.';
  10067 : ErrorMsg:='Too many processes.';
  10091 : ErrorMsg:='Network subsystem is unavailable.';
  10092 : ErrorMsg:='Unsupported version of WINSOCK.DLL.';
  10093 : ErrorMsg:='Successful WSAStartup not yet performed. TCP networking has not been initialized on your computer.';
  10094 : ErrorMsg:='Graceful shutdown in progress.';
  11001 : ErrorMsg:='Host not found. (DNS error.)';
  11002 : ErrorMsg:='Non-authoritative host not found. Temporary DNS error.';
  11003 : ErrorMsg:='Non-recoverable error. (DNS error.)';
  11004 : ErrorMsg:='Valid name, no data record of requested type. (DNS error).';
 else
        ErrorMsg := 'Unknown socket error.';
 end;
 {modif du 13/07/2006}
 ErrorMsg :=CHR(13)+CHR(10)+'Socket Error n' + IntToStr(ErrorCode) + ' : ' + ErrorMsg;
 {The error is managed}
 ErrorCode := 0;
 {definition of the error type}
 case ErrorEvent of
        eeSend          : ErrorMsg := 'Writing error. ' + ErrorMsg;
        eeReceive       : ErrorMsg := 'Reading error. ' + ErrorMsg;
        eeConnect       : ErrorMsg := 'Connecting error. ' + ErrorMsg;
        eeDisconnect : ErrorMsg := 'Disconnecting error. ' + ErrorMsg;
        eeAccept         : ErrorMsg := 'Accepting error. ' + ErrorMsg;
 else
        // erreur inconnue
        ErrorMsg := 'Unknown error. ' + ErrorMsg;
 end;

 DateTime := Time; Date_str := TimeToStr(DateTime);
 {This message specifies that the client is going to disconnect from the server}
 Memo_Log.Lines.Add(Date_Str+': '+ErrorMsg);

 Form1.Disconnection.down:=TRUE;
end;

{*********}

procedure TForm1.FormActivate(Sender: TObject);
begin
 Memo_reception_Text.setfocus;
 FOCUS_ON_MEMO_RECEPTION:=GETFOCUS;
end;

{*************}

procedure TForm1.Memo_Transmission_TextKeyPress(Sender: TObject; var Key: Char);
begin
 {each text character transmitted by the client to the server must be preceded by
 the character CHR(25)}
 ClientSocket1.Socket.SendText(CHR(25)+Key);
end;

{***********}

PROCEDURE TRANSMISSION_TCP_IP_COMMAND(COMMAND:STRING);
{to the Multipsk server}
BEGIN
 {each command string transmitted by the client to the server must be preceded
  by the character CHR(26) and finished by CHR(27)}
 Form1.ClientSocket1.Socket.SendText(CHR(26)+COMMAND+CHR(27));
 {display the command}
 Form1.Memo_reception_Commands.Lines.Add(Date_str+' Command: '+COMMAND);
END;

{*************}

procedure TForm1.Protocol_versionClick(Sender: TObject);
{Request for the protocol version}
VAR COMMAND:STRING;
begin
 COMMAND:='VERSION ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.StateClick(Sender: TObject);
{Request for the Multipsk license presence et present state: RX, STOP, TX}
VAR COMMAND:STRING;
begin
 COMMAND:='STATE ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.TXClick(Sender: TObject);
{TX switching}
VAR COMMAND:STRING;
begin
 COMMAND:='TX';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.RXClick(Sender: TObject);
{RX switching}
VAR COMMAND:STRING;
begin
 COMMAND:='RX';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.RX_AFTER_TXClick(Sender: TObject);
{RX switching after having transmitted all the characters}
VAR COMMAND:STRING;
begin
 COMMAND:='RX_AFTER_TX';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Transceiver_stateClick(Sender: TObject);
{Request for HF frequency (in Hz) and the transceiver mode}
VAR COMMAND:STRING;
begin
 COMMAND:='STATE COMMANDER ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.RX_CommanderClick(Sender: TObject);
{RX switching through the Commander program}
VAR COMMAND:STRING;
begin
 COMMAND:='RX VIA COMMANDER';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.TX_CommanderClick(Sender: TObject);
{TX switching through the Commander program}
VAR COMMAND:STRING;
begin
 COMMAND:='TX VIA COMMANDER';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;


{*************}

procedure TForm1.HF_frequency_via_CommanderClick(Sender: TObject);
{adjustment of the HF frequency in Hz via Commander}
VAR COMMAND:STRING;
begin
 COMMAND:='FR VIA COMMANDER 14074000';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Mode_XCVRClick(Sender: TObject);
{Mode transceiver through the Commander program}
VAR COMMAND:STRING;
begin
 COMMAND:='MODE VIA COMMANDER USB';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_AF_FrequencyClick(Sender: TObject);
{what is the AF frequency and the maximum frequency of the spectrum}
VAR COMMAND:STRING;
begin
 COMMAND:='AF FR ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.AF_frequencyClick(Sender: TObject);
{AF Frequency in Hz in reception}
VAR COMMAND:STRING;
begin
 COMMAND:='AF FR 1234';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_AF_LevelClick(Sender: TObject);
{Request of the level of the received signal from the sound card input}
VAR COMMAND:STRING;
begin
 COMMAND:='LEVEL ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_Signal_to_NoiseClick(Sender: TObject);
{Request of the decoded signal (under the cursor) signal to noise ratio}
VAR COMMAND:STRING;
begin
 COMMAND:='S/N ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_Signal_QualityClick(Sender: TObject);
{Request of the signal quality for the BPSK modes}
VAR COMMAND:STRING;
begin
 COMMAND:='QUALITY ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_intermodulation_distorsionClick(Sender: TObject);
{Request of the intermodulation distorsion in BPSK31, 63...}
VAR COMMAND:STRING;
begin
 COMMAND:='IMD ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_squelchClick(Sender: TObject);
{Request of the squelch level (0 to 10) for the selected digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='SQUELCH ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.SQUELCH_LEVELClick(Sender: TObject);
{Command of the squelch level for the selected digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='SQUELCH 5';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_AFCClick(Sender: TObject);
{Request of the AFC (Automatic frequency control) position for the selected digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='AFC ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.AFC_ONClick(Sender: TObject);
{"AFC ON" to put on, "AFC OFF" would be used to put off}
VAR COMMAND:STRING;
begin
 COMMAND:='AFC ON';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_Master_or_SlaveClick(Sender: TObject);
{Request of the Master switch position for the selected digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='MASTER ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.SlaveClick(Sender: TObject);
VAR COMMAND:STRING;
begin
 COMMAND:='MASTER OFF';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Manual_commandClick(Sender: TObject);
VAR COMMAND:STRING;
begin
 COMMAND:=Edit1.Text;
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_ControlsClick(Sender: TObject);
{Request of the Controls state for the selected digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='CONTROLS ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Very_narrow_filter_in_BPSK31Click(Sender: TObject);
{Control example: Very narrow filter in BPSK31 (the selected mode must be BPSK31)}
VAR COMMAND:STRING;
begin
 COMMAND:='CONTROLS Y';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_PCClick(Sender: TObject);
{Request of the selected PC (radio buttons "450", "166", "66"):
Command: 	PC ?
Answer: 	PC ["450", "166" ou "66"] [PC Problem: "Y" ou "N"]}
VAR COMMAND:STRING;
begin
 COMMAND:='PC ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.PC_66_MHZClick(Sender: TObject);
{Example of command of the selected PC: PC at 66 MHz}
VAR COMMAND:STRING;
begin
 COMMAND:='PC 66';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_SynchroClick(Sender: TObject);
{Request of the synchronization state for the selected digital mode:
This command only concerns modes which might be synchronized (PSKAM, AMTOR...)}
VAR COMMAND:STRING;
begin
 COMMAND:='SYNCHRO ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SpectrumClick(Sender: TObject);
{the samples provided are the ones used by Multipsk for the spectrum and the waterfall}
VAR COMMAND:STRING;
begin
 COMMAND:='SPECTRUM ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Request_modeClick(Sender: TObject);
{Request of the digital mode}
VAR COMMAND:STRING;
begin
 COMMAND:='DIGITAL MODE ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Mode_RTTY_45Click(Sender: TObject);
{Mode selection example: command of selection of the RTTY 45 digital mode, shift=170 Hz in a reversed reception}
{The mode must be given without space. If necessary, the space is replaced by
an underlined, as for example: "RTTY_45" and not "RTTY 45" , "PACTOR_1" and not "PACTOR 1".}
VAR COMMAND:STRING;
begin
 COMMAND:='DIGITAL MODE RTTY_45 170 REV';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Sequence_MacrosClick(Sender: TObject);
{ Sending of a sequence (including macros)}
VAR COMMAND:STRING;
begin
 COMMAND:='SEQUENCE my QTH is <MY QTH>';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Alignment_1500_HzClick(Sender: TObject);
{This command permits to align the present AF reception frequency to the
 selected AF frequency (1500 Hz here), see Multipsk help for details.
 Commander must be connected}
VAR COMMAND:STRING;
begin
 COMMAND:='ALIGNMENT 1500';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Tune_ONClick(Sender: TObject);
{Tune transmission at 1500 Hz}
VAR COMMAND:STRING;
begin
 COMMAND:='TUNE ON 1500';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;


{*************}

procedure TForm1.Tune_OFFClick(Sender: TObject);
{Tune stopping}
VAR COMMAND:STRING;
begin
 COMMAND:='TUNE OFF';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Pax_connection_stateClick(Sender: TObject);
{Request for the state of connection in Pax/Pax2/Packet}
VAR COMMAND:STRING;
begin
 COMMAND:='STATE CONNECTION ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.ConnectClick(Sender: TObject);
{Request to connect in Pax/Pax2/Packet}
VAR COMMAND:STRING;
begin
 COMMAND:='CONNECT';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.DisconnectClick(Sender: TObject);
{Request to connect in Pax/Pax2/Packet}
VAR COMMAND:STRING;
begin
 COMMAND:='DISCONNECT';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.End_of_TCP_IP_connectionClick(Sender: TObject);
{Request to disconnect the TCP-IP connection and Multipsk closure:}
VAR COMMAND:STRING;
begin
 COMMAND:='END_OF_TCP_IP_CONNECTION';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.Multipsk_closureClick(Sender: TObject);
VAR COMMAND:STRING;
begin
 COMMAND:='CLOSE_MULTIPSK';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.MINIMIZEClick(Sender: TObject);
{Request to minimize the RX/TX screen}
VAR COMMAND:STRING;
begin
 COMMAND:='MULTIPSK_MINIMIZE';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{*************}

procedure TForm1.RESIZEClick(Sender: TObject);
{Request to resize the RX/TX screen}
VAR COMMAND:STRING;
begin
 COMMAND:='MULTIPSK_RESIZE';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_SdR_Sampling_frequencyClick(Sender: TObject);
{Force a SdR sampling frequency in Hz (48000, 96000 or 192000 Hz) or what is the SdR sampling frequency in Hz(48000, 96000 or 192000)}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_SF 48000';{SDR_SF 96000, SDR_SF 192000 or SDR_SF ?}
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SdR_SpectrumClick(Sender: TObject);
{the samples provided are the ones used by Multipsk for SdR waterfall}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_SPECTRUM ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_SdR_AF_FrequencyClick(Sender: TObject);
{what is the AF SdR frequency in the SdR spectrum}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_FR ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SdR_AF_frequencyClick(Sender: TObject);
{AF SDR Frequency in the SdR spectrum}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_FR -15000';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Request_SdR_HF_FrequencyClick(Sender: TObject);
{what is the HF SdR central frequency}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_HF_FR ?';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SdR_HF_frequencyClick(Sender: TObject);
{HF SDR central Frequency}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_HF_FR 14074000';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SDR_USBClick(Sender: TObject);
{to force to USB, LSB or to know the selected mode}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_MODE USB';{SDR_MODE LSB or SDR_MODE ?}
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.SDR_VFO_AClick(Sender: TObject);
{to force to VFO A, VFO B or to know the selected VFO}
VAR COMMAND:STRING;
begin
 COMMAND:='SDR_VFO A';{SDR_VFO B or SDR_VFO A ?}
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.FT8Click(Sender: TObject);
{Simple mode (RX only)  selection example: command of selection of the FT8 mode}
VAR COMMAND:STRING;
begin
 COMMAND:='DIGITAL MODE FT8';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

{***********}

procedure TForm1.Button1Click(Sender: TObject);
{Other simple mode (RX/TX) selection example: command of selection of the BPSK31 mode}
VAR COMMAND:STRING;
begin
 COMMAND:='DIGITAL MODE BPSK31';
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
end;

end.
